#include <stdio.h>

main(int argc, char *argv[])
{
	FILE *in1,*in2,*out;
	int numspr1,numspr2,numspr3,width,height;
	unsigned long int sproffset,addoffset;
	unsigned char inbyte,keyboard;
	int counter;
/*	char spr1name[38]="C:\\PROGRA~1\\CREATU~1\\IMAGES\\    .spr";
	char spr2name[38]="C:\\PROGRA~1\\CREATU~1\\IMAGES\\    .spr";
	char spr3name[38]="C:\\PROGRA~1\\CREATU~1\\IMAGES\\    .spr";

	if(argc==4)
	{
		spr1name[28]=argv[1][0];
		spr1name[29]=argv[1][1];
		spr1name[30]=argv[1][2];
		spr1name[31]=argv[1][3];
		spr2name[28]=argv[2][0];
		spr2name[29]=argv[2][1];
		spr2name[30]=argv[2][2];
		spr2name[31]=argv[2][3];
		spr3name[28]=argv[3][0];
		spr3name[29]=argv[3][1];
		spr3name[30]=argv[3][2];
		spr3name[31]=argv[3][3];
	}*/
	char spr1name[9]="    .spr";
	char spr2name[9]="    .spr";
	char spr3name[9]="    .spr";

	if(argc==4)
	{
		spr1name[0]=argv[1][0];
		spr1name[1]=argv[1][1];
		spr1name[2]=argv[1][2];
		spr1name[3]=argv[1][3];
		spr2name[0]=argv[2][0];
		spr2name[1]=argv[2][1];
		spr2name[2]=argv[2][2];
		spr2name[3]=argv[2][3];
		spr3name[0]=argv[3][0];
		spr3name[1]=argv[3][1];
		spr3name[2]=argv[3][2];
		spr3name[3]=argv[3][3];
	}
	else
	{
		fprintf(stderr,"Usage is ADDSPR file1 file2 file3 where filenames\n");
		fprintf(stderr,"are 4 characters long without the extension and\n");
		fprintf(stderr,"all three filenames are different.  The program\n");
		fprintf(stderr,"must be run from within the images directory.\n");
		return(1);
	}

	if((in1=fopen(spr1name,"rb"))==NULL)
	{
		fprintf(stderr,"Cannot open ");
		fprintf(stderr,spr1name);
		fprintf(stderr,"\n");
		return(1);
	}
	printf("Opened %s \n",spr1name);
	if((in2=fopen(spr2name,"rb"))==NULL)
	{
		fprintf(stderr,"Cannot open ");
		fprintf(stderr,spr2name);
		fprintf(stderr,"\n");
		return(1);
	}
	printf("Opened %s \n",spr2name);
	if((out=fopen(spr3name,"rb"))!=NULL)
	{
		fprintf(stderr,spr3name);
		fprintf(stderr," already exists.  Overwrite? (Y/N) ");
		do
			keyboard=getch();
		while((keyboard!='n')&&(keyboard!='N')&&(keyboard!='y')&&(keyboard!='Y'));
		fprintf(stderr,"\n");
		if((keyboard=='n')||(keyboard=='N'))
		{
			fclose(in1);
			fclose(in2);
			fclose(out);
			return(0);
		}
	}
	fclose(out);
	out=fopen(spr3name,"wb");
	fread(&numspr1,2,1,in1);
	fread(&numspr2,2,1,in2);
	numspr3=numspr1+numspr2;
	fwrite(&numspr3,2,1,out);
	addoffset=numspr3*8;
	addoffset+=2;
	printf("Reading in %s header.\n",spr1name);
	for(counter=1;counter<=numspr1;counter++)
	{
		fread(&sproffset,1,4,in1);
		fread(&width,1,2,in1);
		fread(&height,1,2,in1);
		fwrite(&addoffset,1,4,out);
		fwrite(&width,1,2,out);
		fwrite(&height,1,2,out);
      addoffset+=width*height;
	}
	printf("Reading in %s header.\n",spr2name);
	for(counter=1;counter<=numspr2;counter++)
	{
		fread(&sproffset,4,1,in2);
		fread(&width,2,1,in2);
		fread(&height,2,1,in2);
		fwrite(&addoffset,4,1,out);
		fwrite(&width,2,1,out);
		fwrite(&height,2,1,out);
      addoffset+=width*height;
	}
	printf("Reading in %s data.\n",spr1name);
	do
	{
		inbyte=fgetc(in1);
		fputc(inbyte,out);
	}
	while(!(feof(in1)));
	printf("Reading in %s data.\n",spr2name);
	do
	{
		inbyte=fgetc(in2);
		fputc(inbyte,out);
	}
	while(!(feof(in2)));

	fclose(in1);
	fclose(in2);
	fclose(out);

	printf("# Sprites in %s = %u\n",spr1name,numspr1);
	printf("# Sprites in %s = %u\n",spr2name,numspr2);
	printf("# Sprites in %s = %u\n",spr3name,numspr3);
	fprintf(stdout,"Press any key to continue . . .");
	keyboard=getch();
	return(0);
}
